/*
Created by Matjaz Trontelj for Pinegrow Web Editor
Licensed under MIT license
Feel free to use the code in your own Pinegrow plugins
 */
$(function() {

    //Wait for Pinegrow to wake-up
    $("body").one("pinegrow-ready", function(e, pinegrow) {

        //Create new Pinegrow framework object
        var f = new PgFramework("KelvinPinegrowPlugin", "Kelvin");

        var header = new PgComponentType('kelvin.header', 'Header picture');
        header.selector = '.headerwrap';
        header.parent_selector = 'body';
        header.preview_image = 'header.jpg';
        //header.preview_size = 'big';
        header.code = '<div class="headerwrap">\
            <div class="container">\
            <div class="row centered">\
                <div class="col-lg-12">\
                    <h1>William T. Kelvin</h1>\
                    <p class="lead">Web Designer | <a href="mailto:kelvin@blacktie.co">kelvin@blacktie.co</a></p>\
                </div>\
            </div>\
        </div>\
        </div>';
        header.tags = 'major';
        header.sections = {
            'kelvin.header' : {
                name : 'Header options',
                fields : {
                    'kelvin.header.size' : {
                        type : 'select',
                        action: 'apply_class',
                        show_empty: true,
                        name: 'Header size',
                        options: [
                            {key: 'header-large-height', name: "Large"},
                            {key: 'header-full-height', name: "Full screen"}
                        ]
                    },
                    'kelvin.header.captionbck' : {
                        type : 'checkbox',
                        action: 'apply_class',
                        value: 'caption-background',
                        name: 'Caption background'
                    }
                }
            }
        };
        f.addComponentType(header);

        var intro = new PgComponentType('kelvin.intro', 'Intro section');
        intro.selector = '.intro';
        intro.parent_selector = 'body';
        intro.preview_image = 'intro.jpg';
        intro.code = '<div class="intro" id="about">\
            <div class="container">\
            <div class="row">\
                <div class="col-md-2 col-md-offset-1">\
                    <h2>About</h2>\
                </div>\
                <div class="col-md-6">\
                    <p>I\'m web designer &amp; front-end developer with 7 years of professional experience. I\'m interested in all kinds of visual communication, but my major focus is on designing web, mobile &amp; tablet interfaces. I also have skills in other fields\
                    like branding, icon design or web development.</p>\
                </div>\
                <div class="col-md-3">\
                    <p>\
                        <a href="#">\
                            <i class="icon-file"></i>\
                            <sm>DOWNLOAD PDF</sm>\
                        </a>\
                    </p>\
                </div>\
            </div>\
        </div>\
        </div>';
        intro.tags = 'major';
        f.addComponentType(intro);


        var section = new PgComponentType('kelvin.section', 'Section');
        section.selector = '.desc';
        section.parent_selector = 'body';
        section.preview_image = 'section.jpg';
        section.code = function() {
            var sectionid = 'resume';
            return '<div class="container desc bottom-divider" id="' + sectionid + '">\
            <div class="row">\
            <div class="col-md-2 col-md-offset-1">\
                <h2>Education</h2>\
            </div>\
            <div class="col-md-6">\
            <p>\
                <t>Master of Web Design</t>\
                <br/>St. Patrick University\
                <br/><i>3 Years Course</i>\
            </p>\
            <p>Lorem Ipsum is simply dummy text of the printing and typesetting industry. An unknown printer took a galley of type and scrambled it to make a type specimen book.\
            </p>\
        </div>\
            <div class="col-md-3">\
                <p>\
                    <sm>GRADUATING IN MAY 2014\
                        <br>\
                        </sm>\
                        <imp>\
                            <sm>IN PROGRESS</sm>\
                        </imp>\
                    </p>\
                </div>\
            </div>\
            <div class="row">\
                <div class="col-md-6 col-md-offset-3">\
                    <p>\
                        <t>Degree of Web Developer</t>\
                        <br>Hastings University\
                            <br><i>2 Years Course</i>\
                            </p>\
                            <p>Lorem Ipsum is simply dummy text of the printing and typesetting industry. An&nbsp;unknown printer took a galley of type and scrambled it to make a type specimen book.\
                            </p>\
                        </div>\
                        <div class="col-md-3">\
                            <p>\
                                <sm>JUNE 2012</sm>\
                            </p>\
                        </div>\
                    </div>\
                        </div>';
        };
        section.tags = 'major';
        section.action_menu = {
            'add' : ['kelvin.item']
        },
        section.sections = {
            'kelvin.section' : {
                name : 'Section options',
                fields : {
                    'kelvin.section.divider' : {
                        type : 'checkbox',
                        name : 'Bottom divider',
                        value : 'bottom-divider',
                        action : 'apply_class'
                    }
                }
            }
        };
        f.addComponentType(section);


        var item = new PgComponentType('kelvin.item', 'Section item');
        item.selector = null;
        item.preview_image = 'section-item.jpg';
        item.parent_selector = '.desc';
        item.code = '<div class="row">\
            <div class="col-md-6 col-md-offset-3">\
            <p>\
                <t>Web Designer - Intern</t>\
                <br/>Onassis Ltd.\
                <br/>\
            </p>\
            <p>Lorem Ipsum is simply dummy text of the printing and typesetting industry. Lorem Ipsum has been the industry\'s standard dummy text ever since the 1500s, when an unknown printer took a galley of type and scrambled it to make a type specimen\
            book.</p>\
        </div>\
            <div class="col-md-3">\
                <p>\
                    <sm>JUNE 2010 - JULY 2012</sm>\
                </p>\
            </div>\
        </div>';
        item.tags = 'major';
        f.addComponentType(item);


        var section_heading = new PgComponentType('kelvin.section-heading', 'Section title');
        section_heading.selector = null;
        section_heading.parent_selector = '.row';
        section_heading.preview_image = 'title.jpg';
        section_heading.code = '<div class="col-md-2 col-md-offset-1">\
            <h2>Section title</h2>\
        </div>';
        section_heading.tags = 'major';
        f.addComponentType(section_heading);


        var skills = new PgComponentType('kelvin.skills', 'Skills');
        skills.selector = '.skillswrap';
        skills.parent_selector = 'body';
        skills.preview_image = 'skills.jpg';
        skills.on_inserted = function($el) {
            var $canvas = $el.find('canvas.chart');
            $canvas.each(function(i,c) {
                var $c = $(c);
                chart.chartAdded($c);
                chart.showChart($c);
            })
        },
        skills.code = '<div class="skillswrap" id="skills">\
            <div class="container">\
            <div class="row">\
                <div class="col-md-2 col-md-offset-1">\
                    <h2>Skills</h2>\
                </div>\
                <div class="centered col-md-3">\
                    <canvas height="130" width="130" class="chart" data-chart-value="90"></canvas>\
                    <p>Javascript</p>\
                </div>\
                <div class="centered col-md-3">\
                        <canvas height="130" width="130" class="chart" data-chart-value="90"></canvas>\
                        <p>Bootstrap</p>\
                </div>\
                <div class="centered col-md-3">\
                            <canvas height="130" width="130" class="chart" data-chart-value="65"></canvas>\
                            <p>Wordpress</p>\
                </div>\
                <div class="centered col-md-3 col-md-offset-3">\
                                <canvas height="130" width="130" class="chart" data-chart-value="80"></canvas>\
                                <p>HTML/CSS</p>\
                </div>\
                <div class="centered col-md-3">\
                                    <canvas height="130" width="130" class="chart" data-chart-value="70"></canvas>\
                                    <p>Photoshop</p>\
                </div>\
                <div class="centered col-md-3">\
                                        <canvas height="130" width="130" class="chart" data-chart-value="50"></canvas>\
                                        <p>Illustrator</p>\
                </div>\
            </div>\
        </div>\
        </div>';
        skills.tags = 'major';
        skills.action_menu = {
            'add' : ['kelvin.skills.item'],
            on_add : function($el, $new, newdef, prepend) {
                var pgel = new pgQuery($el);
                var pgrow = new pgQuery($($el.find('.row').get(0)));
                var pgnew = new pgQuery($new);

                if(prepend) {
                    pgrow.prepend(pgnew);
                } else {
                    pgrow.append(pgnew);
                }
            }
        },
        f.addComponentType(skills);


        var skills_item = new PgComponentType('kelvin.skills.item', 'Skills item');
        skills_item.selector = '.skill';
        skills_item.parent_selector = '.row';
        skills_item.preview_image = 'skill.jpg';
        skills_item.code = '<div class="centered col-md-3 skill">\
                    <canvas id="javascript" height="130" width="130" class="chart" data-chart-value="90"></canvas>\
                    <p>Javascript</p>\
                </div>';
        skills_item.tags = 'major';
        skills_item.on_inserted = function($el) {
            var $canvas = $el.find('canvas.chart');
            chart.chartAdded($canvas);
            chart.showChart($canvas);
        },
        skills_item.on_changed = function($el) {
            var $canvas = $el.find('canvas.chart');
            chart.chartAdded($canvas);
            chart.showChart($canvas);
        },
        skills_item.on_moved = function($el) {
            var $canvas = $el.find('canvas.chart');
            chart.chartAdded($canvas);
            chart.showChart($canvas);
        },
        f.addComponentType(skills_item);

        var chart = new PgComponentType('kelvin.chart', 'Skill Chart');
        chart.code = '<canvas height="130" width="130" class="chart" data-chart-value="50"></canvas>';
        chart.selector = 'canvas.chart';
        chart.preview_image = 'chart.jpg';
        chart.drag_helper = '<div class="pg-empty-placeholder">Chart</div>';
        chart.tags = 'major';
        chart.on_inserted = function($el) {
            chart.chartAdded($el);
            chart.showChart($el);
        },
        chart.on_changed = function($el) {
            chart.showChart($el);
        },
        chart.sections = {
            'kelvin.chart' : {
                name : 'Chart options',
                fields : {
                    'kelvin.chart.value' : {
                        type : 'text',
                        name : 'Value [0..100]',
                        live_update: false,
                        action : 'custom',
                        get_value: function(obj) {
                            var $el = obj.data;
                            var pgel = new pgQuery($el);
                            return pgel.attr('data-chart-value');
                        },
                        set_value: function(obj, value, values, oldValue, eventType) {
                            var $el = obj.data;
                            var pgel = new pgQuery($el);
                            value = parseInt(value);
                            pgel.attr('data-chart-value', value);
                            //chart.showChart($el);
                            return value;
                        }
                    },
                    'kelvin.chart.value' : {
                        type : 'text',
                        name : 'Value [0..100]',
                        live_update: true,
                        action : 'custom',
                        get_value: function(obj) {
                            var $el = obj.data;
                            var pgel = new pgQuery($el);
                            return pgel.attr('data-chart-value');
                        },
                        set_value: function(obj, value, values, oldValue, eventType) {
                            var $el = obj.data;
                            var pgel = new pgQuery($el);
                            pgel.attr('data-chart-value', value);
                            //chart.showChart($el);
                            return value;
                        }
                    },
                    'kelvin.chart.color' : {
                        type : 'color',
                        name : 'Color',
                        live_update: true,
                        action : 'custom',
                        get_value: function(obj) {
                            var $el = obj.data;
                            var pgel = new pgQuery($el);
                            return pgel.attr('data-chart-color');
                        },
                        set_value: function(obj, value, values, oldValue, eventType) {
                            var $el = obj.data;
                            var pgel = new pgQuery($el);
                            pgel.attr('data-chart-color', value);
                            //chart.showChart($el);
                            return value;
                        }
                    },
                    'kelvin.chart.color.off' : {
                        type : 'color',
                        name : 'Color off',
                        live_update: true,
                        action : 'custom',
                        get_value: function(obj) {
                            var $el = obj.data;
                            var pgel = new pgQuery($el);
                            return pgel.attr('data-chart-color-off');
                        },
                        set_value: function(obj, value, values, oldValue, eventType) {
                            var $el = obj.data;
                            var pgel = new pgQuery($el);
                            pgel.attr('data-chart-color-off', value);
                            chart.showChart($el);
                            return value;
                        }
                    }
                }
            }
        }
        //Custom functions
        chart.showChart = function($el) {
            var id = $el.attr('data-pg-id');
            var code = '$(\'[data-pg-id="' + id + '"]\').trigger(\'chart-update\');';
            var page = pinegrow.getPageForElement($el);
            pinegrow.setIgnoreClicks(true);
            pinegrow.executeScriptInPage(page, code);
            pinegrow.setIgnoreClicks(false);
        }

        chart.chartAdded = function($el) {
            var code = '$(window).trigger(\'chart-added\');';
            var page = pinegrow.getPageForElement($el);
            pinegrow.setIgnoreClicks(true);
            pinegrow.executeScriptInPage(page, code);
            pinegrow.setIgnoreClicks(false);
        }

        f.addComponentType(chart);


        //Portfolio
        var getPortfolioItemCode = function(with_title) {
            var i = Math.floor(Math.random() * 3) + 1;

            var title_code = '';
            if(with_title) {
                title_code = '<div class="col-md-2 col-md-offset-1">\
                <h2>Portfolio</h2>\
                </div>';
            }

            var code = '<div class="row portfolio-item">' + title_code + '\
            <div class="col-md-6' + (with_title ? '' : ' col-md-offset-3') + '">\
                <p>\
                    <img class="img-responsive" src="assets/img/port0' + i + '.jpg" alt="">\
                    </p>\
                </div>\
                <div class="col-md-3">\
                    <p>CANALS OF ENGLAND</p>\
                    <p class="text-success">\
                        <more>Lorem Ipsum is simply dummy text of the printing and typesetting industry. Lorem Ipsum has been the industry\'s standard dummy text ever since the 1500s, when an unknown printer took a galley of type and scrambled it to make a type specimen\
                        book.\
                            <sm>\
                                <i class="icon-tag"></i> design\
                            </sm>\
                        </more>\
                    </p>\
                </div>\
            </div>';


            return code;
        }

        var portfolio = new PgComponentType('kelvin.portfolio', 'Portfolio');
        portfolio.selector = '.portfolio';
        portfolio.parent_selector = 'body';
        portfolio.preview_image = 'portfolio.jpg';
        portfolio.code = '<div class="container desc portfolio" id="portfolio">' + getPortfolioItemCode(true) + getPortfolioItemCode() + getPortfolioItemCode() + '</div>';
        portfolio.tags = 'major';
        portfolio.priority = 100;
        portfolio.action_menu = {
            'add' : ['kelvin.portfolio.item']
        },
        f.addComponentType(portfolio);

        var portfolio_item = new PgComponentType('kelvin.portfolio.item', 'Portfolio item');
        portfolio_item.selector = '.portfolio';
        portfolio_item.parent_selector = '.desc,.portfolio,.container';
        portfolio_item.preview_image = 'portfolio-item.jpg';
        portfolio_item.code = getPortfolioItemCode();
        portfolio_item.tags = 'major';
        f.addComponentType(portfolio_item);

        var footer = new PgComponentType('kelvin.footer', 'Footer');
        footer.selector = '.footwrap';
        footer.parent_selector = 'body';
        footer.preview_image = 'footer.jpg';
        footer.code = '<div class="footwrap">\
            <div class="container" id="contact">\
            <div class="row">\
                <div class="col-md-2 col-md-offset-1">\
                    <h2>Contact</h2>\
                </div>\
                <div class="col-md-6">\
                    <p>\
                        <t>Email</t>\
                        <br><a href="mailto:william@blacktie.co">\
                        william@blacktie.co</a>\
                            <br>\
                            </p>\
                            <p>\
                                <t>Adress</t>\
                                <br>Some Ave. 987\
                                    <br>Postal 23892\
                                        <br>London, England.\
                                            <br>\
                                            </p>\
                                            <p>\
                                                <t>Phone</t>\
                                                <br>+55 8933-2383\
                                                    <br>\
                                                    </p>\
                                                </div>\
                                                <div class="col-md-3">\
                                                    <p>\
                                                        <sm>SOCIAL LINKS</sm>\
                                                    </p>\
                                                    <p class="social-icons"><a href="#"><i class="icon-dribbble"></i></a><a href="#"><i class="icon-twitter"></i></a><a href="#"><i class="icon-facebook"></i></a><a href="#"><i class="icon-linkedin"></i></a><a href="#"><i class="icon-apple"></i></a>\
                                                    </p>\
                                                </div>\
                                            </div>\
                                            <!--/.row -->\
                                        </div>\
                                        <!--/.container -->\
                                    </div>';
        footer.tags = 'major';
        f.addComponentType(footer);


        var copy = new PgComponentType('kelvin.copy', 'Copyright');
        copy.selector = '.copyright';
        copy.parent_selector = 'body';
        copy.preview_image = 'copyright.jpg';
        copy.code = '<div class="copyright">\
            <div class="container">\
            <p>Created by <a href="http://www.blacktie.co">BLACKTIE.CO</a>, built with <a href="http://pinegrow.com">Pinegrow Web Editor</a>.</p>\
            </div>\
        </div>';
        copy.tags = 'major';
        f.addComponentType(copy);



        var topbar = new PgComponentType('kelvin.topbar-icons', 'Topbar icons');
        topbar.selector = '.section-topbar';
        topbar.parent_selector = 'body';
        topbar.preview_image = 'toolbar-icons.jpg';
        topbar.code =   '<div class="section-topbar">\
            <div class="topbar-inner">\
            <div class="container">\
                <div class="row">\
                    <div class="dropdown">\
                        <ul class="nav" id="nav-menu">\
                            <li class="menu-item">\
                                <a class="smoothScroll" href="#about" title="About"><i class="icon-user"></i></a>\
                            </li>\
                            <li class="menu-item">\
                                <a class="smoothScroll" href="#resume" title="Resume"><i class="icon-file"></i></a>\
                            </li>\
                            <li class="menu-item">\
                                <a class="smoothScroll" href="#portfolio" title="Works"><i class="icon-briefcase"></i></a>\
                            </li>\
                            <li class="menu-item">\
                                <a class="smoothScroll" href="#contact" title="Contact"><i class="icon-envelope"></i></a>\
                            </li>\
                        </ul>\
                    </div>\
                    <div class="clear"></div>\
                </div>\
            </div>\
            <div class="clear"></div>\
        </div>\
            </div>';
        topbar.tags = 'major';
        f.addComponentType(topbar);



        var topbarnav = new PgComponentType('kelvin.topbar-nav', 'Topbar navbar');
        topbarnav.selector = '.navbar';
        topbarnav.parent_selector = 'body';
        topbarnav.preview_image = 'toolbar.jpg';
        topbarnav.code = '<nav class="navbar navbar-default navbar-inverse navbar-fixed-top navbar-centered" role="navigation">\
            <div class="container-fluid">\
            <div class="navbar-header">\
                <button type="button" class="navbar-toggle" data-toggle="collapse" data-target="#navbar-collapsed">\
                    <span class="sr-only">Toggle navigation</span>\
                    <span class="icon-bar"></span>\
                    <span class="icon-bar"></span>\
                    <span class="icon-bar"></span>\
                </button>\
            </div>\
            <div class="collapse navbar-collapse text-center" id="navbar-collapsed">\
            <ul class="nav navbar-nav" id="nav-menu">\
                <li class="active">\
                    <a class="smoothScroll" href="#about">About</a>\
                </li>\
                <li>\
                    <a class="smoothScroll" href="#resume">Resume</a>\
                </li>\
                <li>\
                    <a class="smoothScroll" href="#skills">Skills</a>\
                </li>\
                <li>\
                    <a class="smoothScroll" href="#portfolio">Portfolio</a>\
                </li>\
                <li>\
                    <a class="smoothScroll" href="#contact">Contact</a>\
                </li>\
            </ul>\
            </div>\
        </div>\
        </nav>';
        topbarnav.tags = 'major';
        f.addComponentType(topbarnav);



        
        //Tell Pinegrow about the framework
        pinegrow.addFramework(f);
            
        var libsection = new PgFrameworkLibSection("KelvinPinegrowPlugin_lib", "Components");
        //Pass components in array
        libsection.setComponentTypes([topbarnav, topbar, header, intro, section, item, section_heading, skills, skills_item, chart, portfolio, portfolio_item, footer, copy]);

        f.addLibSection(libsection);
   });
});